<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="耗材名称" prop="materialId">
        <el-select v-model="queryParams.materialId" filterable clearable remote reserve-keyword placeholder="请输入耗材名称"
          :remote-method="remoteMethod" :loading="remoteLoading" style="width:300px;">
          <el-option v-for="item in materialList" :key="item.materialId" :label="item.name"
            :value="item.materialId">
            <span style="float: left">{{ item.name }}</span>
            <span style="float: right; color: #8492a6; font-size: 13px">{{ item.brand }}</span>
            <span style="float: right; color: #8492a6; font-size: 13px">{{ item.series }}</span>
          </el-option>
        </el-select>
      </el-form-item>
      <el-form-item label="采购日期" prop="buyTime">
        <el-date-picker clearable v-model="queryParams.buyTime" type="date" value-format="yyyy-MM-dd"
          placeholder="请选择采购日期">
        </el-date-picker>
      </el-form-item>
      <el-form-item label="采购地点" prop="place">
        <el-input v-model="queryParams.place" placeholder="请输入采购地点" clearable @keyup.enter.native="handleQuery" />
      </el-form-item>
      <el-form-item label="采购人" prop="buyer">
        <el-select v-model="queryParams.buyer" filterable clearable @keyup.enter.native="handleQuery">
          <el-option v-for="item in $store.state.user.userList" :key="item.userId" :label="item.nickName"
            :value="item.userId">
          </el-option>
        </el-select>
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button type="primary" plain icon="el-icon-plus" size="mini" @click="handleAdd"
          v-hasPermi="['oa:buy:add']">新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="success" plain icon="el-icon-edit" size="mini" :disabled="single" @click="handleUpdate"
          v-hasPermi="['oa:buy:edit']">修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="danger" plain icon="el-icon-delete" size="mini" :disabled="multiple" @click="handleDelete"
          v-hasPermi="['oa:buy:remove']">删除</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="warning" plain icon="el-icon-download" size="mini" @click="handleExport"
          v-hasPermi="['oa:buy:export']">导出</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="materialBuyList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <!-- <el-table-column label="耗材购买id" align="center" prop="buyId" /> -->
      <!-- <el-table-column label="耗材id" align="center" prop="materialId" /> -->
      <el-table-column label="耗材品牌" align="center" prop="material.brand" />
      <el-table-column label="耗材名称" align="center" prop="material.name" />
      <el-table-column label="规格型号" align="center" prop="material.series" />
      <el-table-column label="采购日期" align="center" prop="buyTime" width="180">
        <template slot-scope="scope">
          <span>{{ parseTime(scope.row.buyTime, '{y}-{m}-{d}') }}</span>
        </template>
      </el-table-column>
      <el-table-column label="采购地点" align="center" prop="place" />
      <el-table-column label="采购数量" align="center" prop="totalNum" />
      <el-table-column label="单价" align="center" prop="price" />
      <el-table-column label="总价" align="center" prop="amount" />
      <el-table-column label="采购人" align="center" prop="buyUser.nickName" />
      <el-table-column label="备注" align="center" prop="remark" />
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button size="mini" type="text" icon="el-icon-edit" @click="handleUpdate(scope.row)"
            v-hasPermi="['oa:buy:edit']">修改</el-button>
          <el-button size="mini" type="text" icon="el-icon-delete" @click="handleDelete(scope.row)"
            v-hasPermi="['oa:buy:remove']">删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination v-show="total > 0" :total="total" :page.sync="queryParams.pageNum" :limit.sync="queryParams.pageSize"
      @pagination="getList" />

    <!-- 添加或修改cmc耗材购买对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="耗材名称" prop="materialId">
          <el-tag v-if="chooseM.name">{{ chooseMname }}</el-tag>
          <el-button type="primary" @click="materialOpen = true" size="mini">耗材选择</el-button>
        </el-form-item>
        <el-form-item label="采购日期" prop="buyTime">
          <el-date-picker clearable v-model="form.buyTime" type="date" value-format="yyyy-MM-dd" placeholder="请选择采购日期">
          </el-date-picker>
        </el-form-item>
        <el-form-item label="采购地点" prop="place">
          <el-input v-model="form.place" placeholder="请输入采购地点" />
        </el-form-item>
        <el-form-item label="采购数量" prop="totalNum">
          <el-input-number :controls="false" v-model="form.totalNum" placeholder="请输入采购数量" @blur="computeAmount()" />
        </el-form-item>
        <el-form-item label="单价" prop="price">
          <el-input-number :controls="false" v-model="form.price" placeholder="请输入单价" @blur="computeAmount()" />
        </el-form-item>
        <el-form-item label="总价" prop="amount">
          <!-- <el-input v-model="form.amount" placeholder="请输入总价" /> -->
          <el-tag>{{ form.amount }}</el-tag>
        </el-form-item>
        <el-form-item label="采购人" prop="buyer">
          <el-select v-model="form.buyer" filterable clearable>
            <el-option v-for="item in $store.state.user.userList" :key="item.userId" :label="item.nickName"
              :value="item.userId">
            </el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="备注" prop="remark">
          <el-input v-model="form.remark" type="textarea" placeholder="请输入备注" />
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
    <el-dialog title="选择耗材" :visible.sync="materialOpen" width="60%" append-to-body :close-on-click-modal="false">
      <choose-materal @confirmChoose="confirmMaterial"></choose-materal>
    </el-dialog>
  </div>
</template>

<script>
import { listMaterialBuy, getMaterialBuy, delMaterialBuy, addMaterialBuy, updateMaterialBuy } from "@/api/oa/material/materialBuy";
import { listMaterial, getMaterial } from "@/api/oa/material/material";
import ChooseMateral from './chooseMateral.vue';

export default {
  name: "MaterialBuy",
  components: { ChooseMateral },
  data() {
    return {
      // 遮罩层
      loading: true,
      remoteLoading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // cmc耗材购买表格数据
      materialBuyList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 50,
        materialId: null,
        buyTime: null,
        place: null,
        totalNum: null,
        price: null,
        amount: null,
        buyer: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        materialId: [
          { required: true, message: '请选择耗材', trigger: 'blur' }
        ],
        buyTime: [
          { required: true, message: '请选择采购日期', trigger: 'change' }
        ],
        totalNum: [
          { required: true, message: '请输入采购数量', trigger: 'blur' }
        ],
        price: [
          { required: true, message: '请输入采购单价', trigger: 'blur' }
        ],
        buyer: [
          { required: true, message: '请选择采购人', trigger: 'change' }
        ]
      },
      materialOpen: false,
      chooseM: {},
      chooseMname: '',
      materialList: []
    };
  },
  created() {
    this.getList();
  },
  methods: {
    /** 查询cmc耗材购买列表 */
    getList() {
      this.loading = true;
      listMaterialBuy(this.queryParams).then(response => {
        this.materialBuyList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        buyId: null,
        materialId: null,
        buyTime: null,
        place: null,
        totalNum: null,
        price: null,
        amount: null,
        buyer: null,
        remark: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.buyId)
      this.single = selection.length !== 1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.chooseM = {};
      this.title = " 新增耗材购买信息";
      this.computeAmount();
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      this.confirmMaterial(row.material)
      const buyId = row.buyId || this.ids
      getMaterialBuy(buyId).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改耗材购买信息";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.buyId != null) {
            updateMaterialBuy(this.form).then(response => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addMaterialBuy(this.form).then(response => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const buyIds = row.buyId || this.ids;
      this.$modal.confirm('是否确认删除cmc耗材购买编号为"' + buyIds + '"的数据项？').then(function () {
        return delMaterialBuy(buyIds);
      }).then(() => {
        this.getList();
        this.$modal.msgSuccess("删除成功");
      }).catch(() => { });
    },
    /** 导出按钮操作 */
    handleExport() {
      this.download('oa/materialBuy/export', {
        ...this.queryParams
      }, `materialBuy_${new Date().getTime()}.xlsx`)
    },
    computeAmount() {
      let amount = (this.form.totalNum * this.form.price).toFixed(2);
      this.$set(this.form, 'amount', amount);
      this.$set(this.form, 'buyer', 17);
    },
    confirmMaterial(row) {
      if (row) {
        this.chooseM = row;
        let brand = row.brand
        let name = row.name
        let series = row.series
        if (brand && series) {
          this.chooseMname = name + '-' + brand + '（' + series + '）'
        } else if (brand == null && series != null) {
          this.chooseMname = name + '（' + series + '）'
        } else if (brand != null && series == null) {
          this.chooseMname = name + '-' + brand
        } else {
          this.chooseMname = name
        }
        this.form.materialId = row.materialId;
        this.materialOpen = false;
        if (this.$refs.form)
          this.$refs.form.validateField('materialId')
      }
    },
    remoteMethod(val) {
      listMaterial({
        pageNum: 1,
        pageSize: 20,
        name: val
      }).then(response => {
        this.materialList = response.rows;
        this.remoteLoading = false;
      });
    }
  }
};
</script>
